import "./accordion.css";
import { defineComponent as i, openBlock as n, createElementBlock as a, mergeProps as s, createElementVNode as l, normalizeClass as d, withModifiers as r, toDisplayString as c, createCommentVNode as p, createBlock as u, resolveDynamicComponent as h, normalizeStyle as f, renderSlot as g } from "vue";
import { a as m } from "../../icons-a06f21ad.js";
import { _ as E } from "../../_plugin-vue_export-helper-dad06003.js";
const v = i({
  props: {
    clickOutside: {
      default: !1,
      type: Boolean
    },
    color: {
      default: "accent",
      type: String
    },
    expand: {
      required: !1,
      type: Boolean
    },
    noElevation: {
      required: !1,
      type: Boolean
    },
    title: {
      required: !1,
      type: String
    }
  },
  name: "sb-accordion",
  data() {
    return {
      localCollapsing: !1,
      localExpanding: !1,
      localExpanded: !1
    };
  },
  computed: {
    angleDown() {
      return m();
    },
    getAccordionStyles() {
      var e;
      if (this.localExpanding || this.localCollapsing) {
        const t = this.$refs[`${this.$.uid}-content`];
        if (t)
          return {
            height: `${((e = t.getBoundingClientRect()) == null ? void 0 : e.height) || 0}px`
          };
      }
      return {};
    }
  },
  methods: {
    handleClickOutsideAccordion(e) {
      const t = e.target, o = this.$refs.accordion;
      this.localExpanded && this.clickOutside && t && o && !o.contains(t) && !t.isSameNode(o) && this.handleToggle(!1);
    },
    handleToggle(e) {
      e && !this.localExpanded ? (this.localExpanding = !0, setTimeout(() => {
        this.localExpanding = !1, this.localExpanded = !0;
      }, 300)) : (this.localCollapsing = !0, setTimeout(() => {
        this.localCollapsing = !1, this.localExpanded = !1;
      }, 150));
    }
  },
  watch: {
    expand: {
      handler(e) {
        this.localExpanded = e || !1;
      },
      immediate: !0
    }
  },
  mounted() {
    document.addEventListener(
      "click",
      (e) => this.handleClickOutsideAccordion(e)
    );
  },
  unmounted() {
    document.removeEventListener(
      "click",
      (e) => this.handleClickOutsideAccordion(e)
    );
  }
});
const y = {
  key: 0,
  class: "title"
};
function $(e, t, o, C, k, x) {
  return n(), a("div", s({
    class: ["accordion", {
      expanded: e.localExpanded || e.localExpanding,
      "no-elevation": e.noElevation
    }],
    ref: "accordion"
  }, { ...e.$attrs }), [
    l("div", {
      class: d(["header-wrapper", [e.color]]),
      onClick: t[0] || (t[0] = r((S) => e.handleToggle(!e.localExpanded), ["stop"]))
    }, [
      e.title ? (n(), a("p", y, c(e.title), 1)) : p("", !0),
      (n(), u(h(e.angleDown)))
    ], 2),
    l("div", {
      class: "content-wrapper",
      style: f(e.getAccordionStyles)
    }, [
      l("div", {
        class: "content",
        ref: `${e.$.uid}-content`
      }, [
        g(e.$slots, "default", {}, void 0, !0)
      ], 512)
    ], 4)
  ], 16);
}
const b = /* @__PURE__ */ E(v, [["render", $], ["__scopeId", "data-v-12eb52db"]]);
export {
  b as default
};
